Subject: Re: [PATCH net] selftests: drv-net: ping: Wait for carrier after toggling offloads

From: Jakub Kicinski <[email-masked]>
Date: Wed, 18 Mar 2026 18:25:31 -0700

On Wed, 18 Mar 2026 17:51:11 -0700 Pin-yen Lin wrote:
> > On Tue, 17 Mar 2026 18:01:17 -0700 Pin-yen Lin wrote:  
> > > Toggling checksum offload (or HW-GRO via feature dependencies) can cause
> > > certain physical interfaces to undergo a reset or a temporary link-down
> > > state. In the ping.py test, this leads to immediate test failures if the
> > > ping is attempted before the carrier is restored.
> > >
> > > This is observed when running the test with GVE driver when HW-GRO is
> > > enabled. When checksum offload is toggled, HW-GRO is toggled as well
> > > because of the feature dependency. This leads to an interface reset,
> > > causing the subsequent ping to fail.
> > >
> > > Add a sleep period after changing these features to allow the link to
> > > stabilize.  
> >
> > Sounds like the test found a legitimate problem. The configuration
> > should not return to user space until the operation has completed.
> > User should not have to sleep 10sec each time they touch NIC
> > configuration.  
> 
> To clarify, the configuration operation itself completes before
> returning to userspace. However, the short link-down during the
> configuration triggers asynchronous systemd events. These userspace
> operations affect the subsequent pings. Sorry for not making this
> clear in the commit message.

Can we somehow avoid / suppress this systemd behavior as part of
(your local) environment setup? Each environment will have some 
setups steps. We assume that DAD is disabled, IPv6 addresses are 
not flushed on ifdown, of course no firewalls..